/*****************************************************************************/
/*                                                                           */
/*  HyperPanel VMOS                     File "stm32/dvmos.c"                 */
/*  Equivalent for stm32 of auto-generated file with "create".               */
/*                                                                           */
/*  Author : PJB                        Last modification : 25/04/2017       */
/*                                                                           */
/*  (c) Copyright HyperPanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/

#include <stdtyp.l>
#include <moteur.h>
#include <armv7m.h>
#include <drv.h>

extern const Dps_driver asy_driver   ; /*                                    */
extern const Dps_driver led_driver   ; /*                                    */
extern const Dps_driver gpio_driver  ; /*                                    */
extern const Dps_driver kbditf_driver; /*                                    */

const Sys_driver * const vmos_driver[]=/*                                    */
  BEGIN                                /*                                    */
    (Sys_driver*)&asy_driver         , /*                                    */
    (Sys_driver*)&led_driver         , /*                                    */
    (Sys_driver*)&gpio_driver        , /*                                    */
    (Sys_driver*)&kbditf_driver      , /*                                    */
    HNULL                            , /*                                    */
  END                                ; /*                                    */

const USHORT  vmos_nbdriver =
          sizeof(vmos_driver)/
          sizeof(Sys_driver *) -1    ; /* Nombre d'elements de vmos_driver   */

IWORD startrun() { return 0;}


#define FAI_SIZE   8
const SHORT fai_size   = FAI_SIZE    ; /* Nombre d'elements dans "fai_evt[]" */
S_evt       fai_evt     [FAI_SIZE   ]; /* Elements des files internes du VMK */
UCHAR       evt_lock    [FAI_SIZE   ]; /* Locks    des files internes du VMK */

#define TASK_SIZE 3
const UCHAR ntaskmax   = TASK_SIZE   ; /* Nombre maximum de taches.          */
Task_ctx    task_ctx    [TASK_SIZE  ]; /* Contexte des taches.               */
USHORT      task_etat   [TASK_SIZE  ]; /* Etat des taches.                   */
Task_system task_sys_ctx[TASK_SIZE  ]; /* Contexte systeme des taches        */

#define TASK_SEM_SIZE   2
const UCHAR ntsemmax = TASK_SEM_SIZE ; /* Nombre max. de semaphores.         */
Task_sem    task_sem  [TASK_SEM_SIZE]; /* Semaphores des taches.             */

#define MAXROUTE   8
const UCHAR  maxroute      = MAXROUTE; /* Nb total de routes.                */
Route       route       [MAXROUTE   ]; /* Tableau global des routes.         */

#define MAXCOND    8
const USHORT sess_cond_max = MAXCOND ; /* Nb total de conditions.            */
Sess_cond   sess_cond   [MAXCOND    ]; /* Tableau global des conditions.     */

#define KBD_MAX    1
const UCHAR  kbd_max       = KBD_MAX ; /* Nombre de voies logiques.          */

#define NTOMAX    16
const UCHAR  hmot_ntomax   = NTOMAX  ; /* 10/50 Nombre maximum de Time - Out */
struct s_to     tabto[NTOMAX]        ; /* Tableau de structures TO           */

#define NAUTMAX   35
const UCHAR  hmot_nautmax  = NAUTMAX ; /* Nombre maximum d'automates         */
const S_trans   *tabtrans[NAUTMAX]  ;  /* Tableau d'adresses de              */
                                       /* tableaux de structures s_trans     */
                                       /* Adresses des tables de             */
                                       /* transition des automates           */
const USHORT   *tablim[NAUTMAX]      ; /* Tableau d'adresses de tableaux     */
                                       /* d'entiers. Adresses des            */
                                       /* tableaux delimitant les etats      */
USHORT         *varetat[NAUTMAX]     ; /* Tableau des adresses des           */
                                       /* vecteurs de variables d'etat       */
struct s_evt   *adrevt[NAUTMAX]      ; /* Tableau d'adresses de              */
                                       /* structures de type s_evt           */
                                       /* Adresse de l'evenement passe       */
                                       /* a la procedure iniaut              */

#define NB_STACK_SZ 1
#define STACK_SZ0   1
#define STACK_SZ1   0
#define STACK_SZ2   0
#define STACK_SZ3   0
#define STACK_SZ4   0
#define STACK_NB0   1
#define STACK_NB1   0
#define STACK_NB2   0
#define STACK_NB3   0
#define STACK_NB4   0

UINT     used_stack [NB_STACK_SZ];
const UCHAR nb_stack_sz = NB_STACK_SZ;

USHORT      stack_sz[] =               /* Table des tailles de piles         */
              BEGIN                    /* (unite: 1 Ko).                     */
                STACK_SZ0,             /*                                    */
                STACK_SZ1,             /*                                    */
                STACK_SZ2,             /*                                    */
                STACK_SZ3,             /*                                    */
                STACK_SZ4              /*                                    */
              END                    ; /*                                    */
                                       /*                                    */
USHORT      stack_nb[] =               /* Table des nombres de piles         */
              BEGIN                    /* de chaque taille.                  */
                STACK_NB0            , /*                                    */
                STACK_NB1            , /*                                    */
                STACK_NB2            , /*                                    */
                STACK_NB3            , /*                                    */
                STACK_NB4              /*                                    */
              END                    ; /*                                    */
                                       /*                                    */
UINT        all_stack_sz = 1024 * (    /* Taille en octets de                */
                STACK_SZ0*STACK_NB0  + /* l'ensemble des piles               */
                STACK_SZ1*STACK_NB1  + /* cumulees.                          */
                STACK_SZ2*STACK_NB2  + /*                                    */
                STACK_SZ3*STACK_NB3  + /*                                    */
                STACK_SZ4*STACK_NB4) ; /*                                    */
                                       /*                                    */
INT         stack [1024 * (            /* L'ensembles des piles              */
                STACK_SZ0*STACK_NB0  + /* allouables, alignees.              */
                STACK_SZ1*STACK_NB1  + /*                                    */
                STACK_SZ2*STACK_NB2  + /*                                    */
                STACK_SZ3*STACK_NB3  + /*                                    */
                STACK_SZ4*STACK_NB4)/ZI]; /*                                 */


#define INIT_VMOS
#define INIT_ENIGMA

#define VMK_USER_NAME "app"
#define VMK_USER_PROC init_myapp
IWORD VMK_USER_PROC(CHAR*,CHAR*) ;
#define INIT_VMK_USER VMK_USER_NAME, 1, 1, VMK_USER_PROC,

const Task_grp task_grp[] =            /* Definition des groupes de taches   */
  BEGIN                                /* ---------------------------------- */
                                       /* Groupes de taches "temps reel" ... */
    INIT_VMOS                          /* VMOS   Hyperpanel.                 */
    INIT_VMK_USER                      /* VMK User App.                      */
                                       /* ---------------------------------- */
                                       /* Groupes de taches "standard" ..... */
    INIT_ENIGMA                        /* Controle d'acces Enigma.           */
                                       /* ---------------------------------- */
    ""             , 9 , 9 , HNULL   , /* Marque de fin de liste ........... */
  END                                ; /* ---------------------------------- */


IWORD hmsg_flag;
//IWORD kbd_stack;

IWORD vlgv;


